%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Programa que transforma l'arxiu drac.carga procedent de GID(problem   %
% type DRAC) en verdat1.carga.                                          %
% Aquest arxiu inclou cond.Cont. de carrega (als nodes) en format DRAC  %
% per a ELEMENTS QUAD PRISM                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
ncarga=input('numero d_elements amb carrega: ');
nelem=input('numero d_elements: ');

fix_carga=[];
conec_carga=[];
prsn=[];
conec_elem=[];

%llegeix arxiu de CARREGUES 
file1=fopen('drac.carga','r');
titol=fgetl(file1);
for icarga=1:ncarga;
    line1=fgetl(file1);
    line_num=str2num(line1);
    fix_carga(icarga,:)=line_num(1:3);
    conec_carga(icarga,:)=line_num(4:6);
    line2=fgetl(file1);
    line_num=str2num(line2);
    prsn(icarga,:)=line_num;
end
%llegeix fitxer de CONECTIVITATS    
file2=fopen('drac.conec','r');
titol=fgetl(file2);
file4=fopen('drac2.conec','w');
fprintf(file4,'%s NEW!\r\n',titol);
for ielem=1:nelem
    aux=fgetl(file2);
    aux2=sscanf(aux,'%i',90);
    conec_elem(ielem,:)=aux2';
    fprintf(file4,'%5i%5i%5i%7i%7i%7i%7i%7i%7i%7i%7i%7i%7i%7i%7i%7i%7i%7i\r\n',aux2');
end


%Noves carregues als nodes.
new_conec_carga=[];
file3=fopen('verdat1.carga','w');
fprintf(file3,'CC carrega quadratic!\r\n');
for icarga=1:ncarga
    nodes_int=[conec_elem(fix_carga(icarga,2),12) conec_elem(fix_carga(icarga,2),11) conec_elem(fix_carga(icarga,2),10)];
    new_conec_carga(icarga,:)=[conec_carga(icarga,:) nodes_int];
   fprintf(file3,'%5i%5i%5i%5i%5i%5i%5i%5i%5i\r\n',fix_carga(icarga,:),new_conec_carga(icarga,:));
   fprintf(file3,'%8.2f%8.2f%8.2f%8.2f%8.2f%8.2f\r\n',prsn(icarga,:),prsn(icarga,:));
end
fclose(file1);
fclose(file2);
fclose(file3);
fclose(file4);