function [int_N,int_M,int_Q]=esfor_lamina(sigma_pila,elemppila,gruix);

%inicialitzem vectors
int_N=[];
int_M=[];
int_Q=[];
%parametres
gruix_el=gruix/elemppila;
lim_sup=gruix/2;
lim_inf=-gruix/2;
z_gauss=[-0.57735 0.57735];

for i=1:elemppila
  %agafem les tensions de l'element de la pila.
  sigma_gauss1=sigma_pila(2*i-1,:);
  sigma_gauss2=sigma_pila(2*i,:);
  %expressio del canvi de variable per cada element de la pila i.
  inf_el=lim_inf+(i-1)*gruix_el;
  sup_el=lim_inf+i*gruix_el;
  b=(inf_el+sup_el)/2;
  a=sup_el-b;
  %esforos de membrana N.
  N_sigma=[sigma_gauss1(2) sigma_gauss1(3) sigma_gauss1(5);
           sigma_gauss2(2) sigma_gauss2(3) sigma_gauss2(5)]';
  int_N(:,i)=a*(N_sigma(:,1)+N_sigma(:,2));
  %moments flectors M.
  M_sigma=N_sigma';
 int1=a*((z_gauss*M_sigma)');
 M_sigma=M_sigma';
 int2=b*(M_sigma(:,1)+M_sigma(:,2));
 int_M(:,i)=a*(int1+int2);
 %tallants Q.
 Q_sigma=[sigma_gauss1(4) sigma_gauss1(6);
      sigma_gauss2(4) sigma_gauss2(6)]';
 int_Q(:,i)=a*(Q_sigma(:,1)+Q_sigma(:,2));
end
