%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%       Programa que calcula el les tensions efectives de VON MISES   %%      
%%       i DRUCKER-PRAGER a patir dels arxius de tensions xxx.TEC      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
%%%%%%%%%%
tensio_gauss=[];
tensio_efect=[];
npg_prsm=6;
npg_tetr=1;
incr=input('stage step load_incr ?: ');
nelem=input('numero d_elements?: ');
descr=input('nomdescripcio del cas ?: ');
str_file_tec=sprintf('%s_%s.tec',descr,incr);
file01=fopen(str_file_tec,'r');

titol=fgetl(file01);
nfiles=0;
str_file02=sprintf('vonmises_prsm_%s.res',incr);
str_file03=sprintf('vonmises_tetr_%s.res',incr);
str_file04=sprintf('dprager_prsm_%s.res',incr);
str_file05=sprintf('dprager_tetr_%s.res',incr);
file02=fopen(str_file02,'w');
file03=fopen(str_file03,'w');
fprintf(file02,'Arxiu resultats tensions efectives de VM elements PRSM\r\n');
fprintf(file03,'Arxiu resultats tensions efectives de VM elements TETR\r\n');
file04=fopen(str_file04,'w');
file05=fopen(str_file05,'w');
fprintf(file02,'Arxiu resultats tensions efectives de DP elements PRSM\r\n');
fprintf(file03,'Arxiu resultats tensions efectives de DP elements TETR\r\n');

for ielem=1:nelem
    aux=fgetl(file01);
    aux2=sscanf(aux','%i%i',90);
    a(ielem,:)=aux2';
       
    if a(ielem,2)==2;
        fprintf(file02,'  %i ',ielem);
        fprintf(file04,'  %i ',ielem);
        for jpg=1:npg_prsm;
        nfiles=nfiles+1;
        aux_pg=fgetl(file01);
        pg=sscanf(aux_pg,'%e %e %e %e %e %e',90);
        tensio_gauss(nfiles,:)=[ielem pg'];
        %%%%%%TENSIO EFECTIVA DE VON MISES%%%%%%%%%%%%%%%%%%%%%%%%%%%
        t1=(pg(1)-pg(2))^2;
        t2=(pg(2)-pg(3))^2;
        t3=(pg(3)-pg(1))^2;
        t4=pg(4)^2;
        t5=pg(5)^2;
        t6=pg(6)^2;
        j2=(t1+t2+t3+t4+t5+t6)/6;
        vm=sqrt(j2*3);
        %%%%%%TENSIO EFECTIVA DE DRUCKER-PRAGER%%%%%%%%%%%%%%%%%%%%%%
        fi=pi*70/180;
        alpha=(2*sin(fi))/((sqrt(3))*(3-sin(fi)));
        i_uno=pg(1)+pg(2)+pg(3);
        dp=(alpha*i_uno-sqrt(j2))/(alpha+(1/sqrt(3)));
        tensio_efect(nfiles,:)=[ielem vm dp];
        fprintf(file02,'  %f \r\n',vm);
        fprintf(file04,'  %f \r\n',dp);
        end
        
    end
    if a(ielem,2)==4;
        fprintf(file03,'  %i ',ielem);
        fprintf(file05,'  %i ',ielem);
        for jpg=1:npg_tetr;
        nfiles=nfiles+1;
        aux_pg=fgetl(file01);
        pg=sscanf(aux_pg,'%e %e %e %e %e %e',90);
        tensio_gauss(nfiles,:)=[ielem pg'];
        %%%%%%TENSIO EFECTIVA DE VON MISES%%%%%%%%%%%%%%%%%%%%%%%%%%%
        t1=(pg(1)-pg(2))^2;
        t2=(pg(2)-pg(3))^2;
        t3=(pg(3)-pg(1))^2;
        t4=pg(4)^2;
        t5=pg(5)^2;
        t6=pg(6)^2;
        j2=(t1+t2+t3+t4+t5+t6)/6;
        vm=sqrt(j2*3);
        %%%%%%TENSIO EFECTIVA DE DRUCKER-PRAGER%%%%%%%%%%%%%%%%%%%%%%
        fi=pi*70/180;
        alpha=(2*sin(fi))/((sqrt(3))*(3-sin(fi)));
        i_uno=pg(1)+pg(2)+pg(3);
        dp=(alpha*i_uno-sqrt(j2))/(alpha+(1/sqrt(3)));
        tensio_efect(nfiles,:)=[ielem vm dp];
        fprintf(file03,'  %f \r\n',vm);
        fprintf(file05,'  %f \r\n',dp);
        end
        
    end
    
end
   
fclose(file01);
fclose(file02);
fclose(file03);
fclose(file04);
fclose(file05);

    

