%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%       Programa que calcula el les tensions efectives de VON MISES   %%      
%%       i DRUCKER-PRAGER a patir dels arxius de tensions xxx.TEC      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
%%%%%%%%%%
tensio_gauss=[];
tensio_efect=[];
npg_prsm=8;
npg_tetr=1;
incr=input('stage step load_incr ?: ');
descr=input('nomdescripcio del cas ?: ');
str_file_tec=sprintf('%s_%s.tec',descr,incr);
nelem=input('numero d_elements?: ');
file01=fopen(str_file_tec,'r');
titol=fgetl(file01);
nfiles=0;
str_file02=sprintf('vonmises_lamina_%s.res',incr);
str_file03=sprintf('dprager_lamina_%s.res',incr);
file02=fopen(str_file02,'w');
file03=fopen(str_file03,'w');
fprintf(file02,'Arxiu resultats tensions efectives de VM LAMINA\r\n');
fprintf(file03,'Arxiu resultats tensions efectives de DP LAMINA\r\n');

teffVM=[];
teffDP=[];

for ielem=1:nelem
    teff_elem=[];
    aux=fgetl(file01);
    aux2=sscanf(aux','%i%i',90);
    a(ielem,:)=aux2';
       
    if a(ielem,2)==2;
        vm_elem=[];
        dp_elem=[];
        nfiles=nfiles+1;
        for jpg=1:npg_prsm;
        aux_pg=fgetl(file01);
        pg=sscanf(aux_pg,'%e %e %e %e %e %e',90);
        %tensio_gauss(nfiles,:)=[ielem pg'];
        %%%%%%TENSIO EFECTIVA DE VON MISES%%%%%%%%%%%%%%%%%%%%%%%%%%%
        t1=(pg(1)-pg(2))^2;
        t2=(pg(2)-pg(3))^2;
        t3=(pg(3)-pg(1))^2;
        t4=pg(4)^2;
        t5=pg(5)^2;
        t6=pg(6)^2;
        j2=(t1+t2+t3+t4+t5+t6)/6;
        vm=sqrt(j2*3);
        vm_elem(jpg)=vm;
        %%%%%%TENSIO EFECTIVA DE DRUCKER-PRAGER%%%%%%%%%%%%%%%%%%%%%%
        fi=pi*70/180;
        alpha=(2*sin(fi))/((sqrt(3))*(3-sin(fi)));
        i_uno=pg(1)+pg(2)+pg(3);
        dp=(alpha*i_uno-sqrt(j2))/(alpha+(1/sqrt(3)));
        dp_elem(jpg)=dp;
        end
        teffVM(nfiles,:)=[a(ielem,1) vm_elem];
        teffDP(nfiles,:)=[a(ielem,1) dp_elem];
    end
    
     if a(ielem,2)==4;
        for jpg=1:npg_tetr;
        nfiles=nfiles+1;
        aux_pg=fgetl(file01);
        pg=sscanf(aux_pg,'%e %e %e %e %e %e',90);
        end
    end
end
    
%%%%%%%%%%%%%%%%%%%% INFORMACIO DE PILES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[titol,pila]=hdrload('drac_piles.conec');
n_pila=length(pila(:,1));
elemppila=length(pila(1,:));

VM_pila=[];
DP_pila=[];
for ipila=1:n_pila;
        fprintf(file02,'  %i ',ipila);
        fprintf(file03,'  %i ',ipila);

    for j=1:elemppila
     elem_pila=pila(ipila,j);
     VM_pila(j,:)=teffVM(elem_pila,2:(npg_prsm+1));
     DP_pila(j,:)=teffDP(elem_pila,2:(npg_prsm+1));
     end
    vm_max=max(max(VM_pila));
    dp_max=max(max(DP_pila));
    fprintf(file02,'  %f \r\n',vm_max);
    fprintf(file03,'  %f \r\n',dp_max);
 
 end
    
   
fclose(file01);
fclose(file02);
fclose(file03);
