C*++++++++++++++++++++***********++++++++++++++++++++*********++++++++++++*****
C                                                                             *
C     PROGRAMA PARA GENERAR LOS NUDOS INTERMEDIOS, SUS COORDENADAS Y          *
C     LAS CONDICIONES DE CONTORNO Y CARGAS DE UNA DISCRETIZACION DE           *
C     ELEMENTOS TRIDIMENSIONALES CON ARISTAS DE 3 NUDOS(2 EXTREMOS Y          *
C     UNO INTERMEDIO)                                                         *
C                                                                             *
C    Version para convertir de lineal a cuadratico el input de NTDJ3          *
C                                                                             *
C******************************************************************************
      INCLUDE 'NTDJ3COM.FOR'
C
      CHARACTER TEXTO1*80,TEXTO2*80,TEXTO3*80
      DIMENSION NRESTO(8),IVECT(16),KPFIX(MPOIN)
      DIMENSION LISTA_DE_ARISTAS(2,MPOIN),IRENJ(16,2),PRESS(8)
      DIMENSION NVERC(NTIPC),NARIC(NTIPC),NVERJ(NTIPJ),NARIJ(NTIPJ)
C
C      DIMENSION NUMEL(125,3),MATNO(125,3),LNODS(20,125,3),
C     .          KARIS(3,12,125,3),KTIPEL(375),COORD(3,1000)
C      DIMENSION NNODE(3),NVERTI(3),NARIS(3),NELEM(3),IELEMI(3),JELEMI(3)
C      DIMENSION NOFIX(500),IFPRE(3,500),PRESC(3,500),KPFIX(1000),
C     .          NOPRS(8),PRESS(8)
C
      DATA NPROJ/3,14/
      DATA NVERC/8,6,5,4/
      DATA NVERJ/8,6/
      DATA NARIC/12,9,8,6/
      DATA NARIJ/8,6/
      DATA KARIC/1,2,2,3,3,4,4,1,1,5,2,6,3,7,4,8,5,6,6,7,7,8,8,5,16*0,
     .           1,2,2,3,3,1,1,4,2,5,3,6,4,5,5,6,6,4,0,0,0,0,0,0,16*0,
     .           1,2,2,3,3,4,4,1,1,5,2,5,3,5,4,5,0,0,0,0,0,0,0,0,16*0,
     .           1,2,2,3,3,1,1,4,2,4,3,4,0,0,0,0,0,0,0,0,0,0,0,0,16*0/
      DATA KARIJ/1,2,2,3,3,4,4,1,5,6,6,7,7,8,8,5,16*0,
     .           1,2,2,3,3,1,4,5,5,6,6,4,0,0,0,0,16*0/
      DATA IRENJ/1,2,3,4,9,10,11,12,5,6,7,8,13,14,15,16,
     .           1,2,3,7,8,9,4,5,6,10,11,12,0,0,0,0/
C
      DO I=1,4
        NNODC(I)=NVERC(I)+NARIC(I)
      END DO
      DO I=1,2
        NNODJ(I)=NVERJ(I)+NARIJ(I)
      END DO
C
C * Dos lineas de texto
C
      READ(5,890)TEXTO1
  890 FORMAT(A80)
      READ(5,890)TEXTO2
C
C * Datos generales
C
      READ(5,900)NPOI0,NELEC,NELEJ,NSTEP,NMATC,NMATJ,(NRESTO(I),I=1,8)
  900 FORMAT(16I5)
      NPGEO=NRESTO(4)
C
C * Controles
C
      IF(NPOI0.GT.MPOIN)THEN
        WRITE(6,*)' NPOI0 > MPOIN'
        STOP
      END IF
C
      IF(NPGEO.GT.MPGEO)THEN
        WRITE(6,*)' NPGEO > MPGEO'
        STOP
      END IF
C
      IF(NELEC.GT.MELEC)THEN
        WRITE(6,*)' NELEC > MELEC'
        STOP
      END IF
C
      IF(NELEJ.GT.MELEJ)THEN
        WRITE(6,*)' NELEJ > MELEJ'
        STOP
      END IF
C
      IF(NMATC.GT.MMATC)THEN
        WRITE(6,*)' NMATC > MMATC'
        STOP
      END IF
C
      IF(NMATJ.GT.MMATJ)THEN
        WRITE(6,*)' NMATJ > MMATJ'
        STOP
      END IF
C
C * Lee datos proc. iterativo como un texto
C
      READ(5,890)TEXTO3
C-----------------------------------
C * Lee els. m.c.
C
      IF(NELEC.EQ.0)GO TO 18
      DO IELEC=1,NELEC
        DO INODC=1,MNGEC
          LNODC(INODC,IELEC)=0
        END DO
      END DO
C
      IELEC=0
    9 READ(5,900)(IVECT(I),I=1,15)
      IF(IVECT(1).NE.0)THEN
        IF(IELEC.EQ.NELEC)THEN
          WRITE(6,*)' ERROR - FALTA LINEA FINAL ELEMS M.C.'
          STOP
        END IF
        IELEC=IELEC+1
        ITIPC(IELEC)=IVECT(2)
        LMATC(IELEC)=IVECT(3)
        DO INODC=1,NVERC(ITIPC(IELEC))
          LNODC(INODC,IELEC)=IVECT(INODC+3)
        END DO
      ELSE
        NVERT=NVERC(ITIPC(IELEC))
        NNODE=NNODC(ITIPC(IELEC))
        DO INODE=NVERT+1,NNODE
          LNODC(INODE,IELEC)=IVECT(INODE-NVERT+3)
        END DO
        IF(IELEC.EQ.NELEC)GOTO 18
      END IF
      GOTO 9
C
C * Lee elementos junta
C
   18 IF(NELEJ.EQ.0)GO TO 28
      DO IELEJ=1,NELEJ
        DO INODJ=1,MNGEJ
          LNODJ(INODJ,IELEJ)=0
        END DO
      END DO
C
      IELEJ=0
   19 READ(5,900)(IVECT(I),I=1,15)
      IF(IVECT(1).NE.0)THEN
        IF(IELEJ.EQ.NELEJ)THEN
          WRITE(6,*)' ERROR - FALTA LINEA FINAL ELEMS JUNTA'
          STOP
        END IF
        IELEJ=IELEJ+1
        ITIPJ(IELEJ)=IVECT(2)
        LMATJ(IELEJ)=IVECT(3)
        DO INODJ=1,NVERJ(ITIPJ(IELEJ))
          LNODJ(INODJ,IELEJ)=IVECT(INODJ+3)
        END DO
      ELSE
        NVERT=NVERJ(ITIPJ(IELEJ))
        NNODE=NNODJ(ITIPJ(IELEJ))
        DO INODE=NVERT+1,NNODE
          LNODJ(INODE,IELEJ)=IVECT(INODE-NVERT+3)
        END DO
        IF(IELEJ.EQ.NELEJ)GOTO 28
      END IF
      GOTO 19
C
   28 CONTINUE
C
C * Lee coords. nodales nudos de vertice
C
      DO IPOIN=1,NPOI0
        READ(5,940)I,(COORD(IDIME,IPOIN),IDIME=1,NDIME)
  940   FORMAT(I5,3F10.4)
      END DO
C
C * Lee coords. nodales nudos intermedios (geometria)
C
      IF(NPGEO.GT.0)THEN
        DO IPGEO=1,NPGEO
          READ(5,940)I,(COGEO(IDIME,IPGEO),IDIME=1,NDIME)
        END DO
      END IF
C
C * Lee carac. materiales m.c.
C
      IF(NMATC.EQ.0)GO TO 101
      DO 100 IMATC=1,NMATC
        READ(5,931) NUMAT,(CMATC(J,NUMAT),J=1,NPROC)
  931   FORMAT(I5,F10.5,F10.0,F10.5)
  100 CONTINUE
  101 CONTINUE
C
C * Lee caract. "materiales" junta.
C
      IF(NMATJ.EQ.0)GO TO 111
      DO 110 IMATJ=1,NMATJ
        READ(5,981)NUMAT,KTL,(CMATJ(J,NUMAT),J=1,NPROJ(KTL))
  981   FORMAT(2I5,2F10.0,5F10.5,/,10X,7F10.5)
        KTLCJ(NUMAT)=KTL
  110 CONTINUE
  111 CONTINUE
C-------------------------------------------------------------------------
C
C * Recorre las aristas de los elems. de m.c. generando nuevos nudos
C
      NPOIN=NPOI0
      DO 390 IELEM=1,NELEC
        ITIPE=ITIPC(IELEM)
        DO 390 IARIS=1,NARIC(ITIPE)
          INODE=NVERC(ITIPE)+IARIS
          IP1=LNODC(KARIC(1,IARIS,ITIPE),IELEM)
          IP2=LNODC(KARIC(2,IARIS,ITIPE),IELEM)
C
          IF(IELEM.GT.1)THEN
          DO JELEM=1,IELEM-1            ! Repasa si ya ha aparecido
            JTIPE=ITIPC(JELEM)
            DO JARIS=1,NARIC(JTIPE)
              JP1=LNODC(KARIC(1,JARIS,JTIPE),JELEM)
              JP2=LNODC(KARIC(2,JARIS,JTIPE),JELEM)
              IF((IP1.EQ.JP1.AND.IP2.EQ.JP2).OR.
     .           (IP1.EQ.JP2.AND.IP2.EQ.JP1))THEN
C                         ................ Nudo que ya existia
                JNODE=NVERC(JTIPE)+JARIS
                LNODC(INODE,IELEM)=LNODC(JNODE,JELEM)
                GOTO 390
              END IF
            END DO
          END DO
          END IF
C                      ....................Nuevo nudo arista
          NPOIN=NPOIN+1
          IF(NPOIN.GT.MPOIN)THEN
            WRITE(6,*)' NPOIN > MPOIN EN ARISTAS ELS.M.C.'
            STOP
          END IF
          LISTA_DE_ARISTAS(1,NPOIN-NPOI0)=IP1
          LISTA_DE_ARISTAS(2,NPOIN-NPOI0)=IP2
          IPM=LNODC(INODE,IELEM)
          LNODC(INODE,IELEM)=NPOIN
          IF(IPM.EQ.0)THEN
            DO J=1,3
              COORD(J,NPOIN)=(COORD(J,IP1)+COORD(J,IP2))/2.
            END DO
          ELSE
            DO J=1,3
              COORD(J,NPOIN)=COGEO(J,IPM)
            END DO
          END IF
C
  390 CONTINUE
C
C * Ahora las aristas de juntas
C
      DO 490 IELEM=1,NELEJ
        ITIPE=ITIPJ(IELEM)
        DO 490 IARIS=1,NARIJ(ITIPE)
          INODE=NVERJ(ITIPE)+IARIS
          IP1=LNODJ(KARIJ(1,IARIS,ITIPE),IELEM)
          IP2=LNODJ(KARIJ(2,IARIS,ITIPE),IELEM)
C
          IF(NELEC.GT.0)THEN
          DO JELEM=1,NELEC           ! Comprueba si no ha salido en el m.c
            JTIPE=ITIPC(JELEM)
            DO JARIS=1,NARIC(JTIPE)
              JP1=LNODC(KARIC(1,JARIS,JTIPE),JELEM)
              JP2=LNODC(KARIC(2,JARIS,JTIPE),JELEM)
              IF((IP1.EQ.JP1.AND.IP2.EQ.JP2).OR.
     .           (IP1.EQ.JP2.AND.IP2.EQ.JP1))THEN
C                         ................ Nudo que ya existia
                JNODE=NVERC(JTIPE)+JARIS
                JPM=LNODC(JNODE,JELEM)
                LNODJ(INODE,IELEM)=JPM
                GOTO 490
              END IF
            END DO
          END DO
          END IF
C
          IF(IELEM.GT.1)THEN
          DO JELEM=1,IELEM-1         ! Comprueba si no ha salido en las juntas
            JTIPE=ITIPJ(JELEM)
            DO JARIS=1,NARIJ(JTIPE)
              JP1=LNODJ(KARIJ(1,JARIS,JTIPE),JELEM)
              JP2=LNODJ(KARIJ(2,JARIS,JTIPE),JELEM)
              IF((IP1.EQ.JP1.AND.IP2.EQ.JP2).OR.
     .           (IP1.EQ.JP2.AND.IP2.EQ.JP1))THEN
C                         ................ Nudo que ya existia
                JNODE=NVERJ(JTIPE)+JARIS
                JPM=LNODJ(JNODE,JELEM)
                LNODJ(INODE,IELEM)=JPM
                GOTO 490
              END IF
            END DO
          END DO
          END IF
C                      ....................Nuevo nudo
          NPOIN=NPOIN+1
          IF(NPOIN.GT.MPOIN)THEN
            WRITE(6,*)' NPOIN > MPOIN EN ARISTAS ELS.JUN.'
            STOP
          END IF
          LISTA_DE_ARISTAS(1,NPOIN-NPOI0)=IP1
          LISTA_DE_ARISTAS(2,NPOIN-NPOI0)=IP2
          IPM=LNODJ(INODE,IELEM)
          LNODJ(INODE,IELEM)=NPOIN
          IF(IPM.EQ.0)THEN
            DO J=1,3
              COORD(J,NPOIN)=(COORD(J,IP1)+COORD(J,IP2))/2.
            END DO
          ELSE
            DO J=1,3
              COORD(J,NPOIN)=COGEO(J,IPM)
            END DO
          END IF
C
  490 CONTINUE
C
C----------------------------------------------------------------------
C * Empieza a escribir el nuevo archivo
C
      WRITE(6,890)TEXTO1
      WRITE(6,890)TEXTO2
      WRITE(6,900)NPOIN,NELEC,NELEJ,NSTEP,NMATC,NMATJ,(NRESTO(I),I=1,8)
      WRITE(6,890)TEXTO3
C
      IF(NELEC.GT.0)THEN
        DO IELEC=1,NELEC
          WRITE(6,'(16I5,/,15X,13I5)')IELEC,ITIPC(IELEC),LMATC(IELEC),
     .                (LNODC(J,IELEC),J=1,NNODC(ITIPC(IELEC)))
        END DO
      END IF
      IF(NELEJ.GT.O)THEN
        DO IELEJ=1,NELEJ
          ITIPE=ITIPJ(IELEJ)
          WRITE(6,'(16I5,/,15X,13I5)')IELEJ,ITIPJ(IELEJ),LMATJ(IELEJ),
     .            (LNODJ(IRENJ(J,ITIPE),IELEJ),J=1,NNODJ(ITIPJ(IELEJ)))
        END DO
      END IF
C
      DO IPOIN=1,NPOIN
        WRITE(6,940)IPOIN,(COORD(J,IPOIN),J=1,3)
      END DO
C
      IF(NMATC.GT.0)THEN
      DO NUMAT=1,NMATC
        WRITE(6,931)NUMAT,(CMATC(J,NUMAT),J=1,NPROC)
      END DO
      END IF
C
      IF(NMATJ.GT.0)THEN
      DO NUMAT=1,NMATJ
        KTL=KTLCJ(NUMAT)
        WRITE(6,981)NUMAT,KTL,(CMATJ(J,NUMAT),J=1,NPROJ(KTL))
      END DO
      END IF
C
C----------------------------------------------------------------------
C * CONDICIONES DE CONTORNO Y CARGAS PARA CADA STEP DE ACCIONES
C
      DO 690 ISTEP=1,NSTEP
        READ(5,'(A80)')TEXTO1
        WRITE(6,'(A80)')TEXTO1
        READ(5,'(A80)')TEXTO2
        WRITE(6,'(A80)')TEXTO2
        READ(5,900)NPFI0,NPLOD,IGRAV,NEDGE
C
C * Control
C
        IF(NPFI0.GT.MPFIX)THEN
          WRITE(6,*)' NPFI0 > MPFIX'
          STOP
        END IF
C
C * COACCIONES NODALES Y DESPL.IMP.
C
        DO IPOIN=1,NPOIN
          KPFIX(IPOIN)=0
        END DO
C
        DO IPFI0=1,NPFI0
          READ(5,970)NOFIX(IPFI0),(IFPRE(J,IPFI0),J=1,3),
     .               (DESIM(J,IPFI0),J=1,3)
  970     FORMAT(I5,2X,3I1,3F10.6)
          KPFIX(NOFIX(IPFI0))=IPFI0
        END DO
C
        DO IPFIX=NPFI0+1,MPFIX
          DO IGDLN=1,NGDLN
            IFPRE(IGDLN,IPFIX)=0
            DESIM(IGDLN,IPFIX)=0.0
          END DO
        END DO
C
        NPFIX=NPFI0
        DO IPOIN=NPOI0+1,NPOIN
          IPFI1=KPFIX(LISTA_DE_ARISTAS(1,IPOIN-NPOI0))
          IPFI2=KPFIX(LISTA_DE_ARISTAS(2,IPOIN-NPOI0))
          IF(IPFI1.NE.0.AND.IPFI2.NE.0)THEN
            IFFFF=0
            DO IGDLN=1,NGDLN
              IF(IFPRE(IGDLN,IPFI1).EQ.1.AND.
     .           IFPRE(IGDLN,IPFI2).EQ.1)THEN
                IF(IFFFF.EQ.0)THEN
                  NPFIX=NPFIX+1
                  IF(NPFIX.GT.MPFIX)THEN
                    WRITE(6,*)' NPFIX > MPFIX'
                    STOP
                  END IF
                  NOFIX(NPFIX)=IPOIN
                  KPFIX(IPOIN)=NPFIX
                  IFFFF=1
                END IF
                IFPRE(IGDLN,NPFIX)=1
                DESIM(IGDLN,NPFIX)=(DESIM(IGDLN,IPFI1)+
     .                              DESIM(IGDLN,IPFI2))/2.
              END IF
            END DO
          END IF
        END DO
C
C * Lo escribe
C
        WRITE(6,900)NPFIX,NPLOD,IGRAV,NEDGE
        DO IPFIX=1,NPFIX
          WRITE(6,970)NOFIX(IPFIX),(IFPRE(J,IPFIX),J=1,3),
     .                (DESIM(J,IPFIX),J=1,3)
        END DO
C
C * Cargas  puntuales  y gravedad
C
        IF(NPLOD.GT.0)THEN
        DO IPLOD=1,NPLOD
          READ(5,'(A80)')TEXTO1
          WRITE(6,'(A80)')TEXTO1
        END DO
        END IF
C
        IF(IGRAV.EQ.1)THEN
          READ(5,'(A80)')TEXTO1
          WRITE(6,'(A80)')TEXTO1
        END IF
C
C * Cargas de superficie
C
        IF(NEDGE.GT.0)THEN
        DO IEDGE=1,NEDGE
          READ(5,900)I,IELEM,IT,(IVECT(I),I=1,NNODJ(IT)/4)
          READ(5,'(8F10.3)')(PRESS(I),I=1,NNODJ(IT)/4)
          NARIS=NNODJ(IT)/4
          DO 590 IARIS=1,NARIS
            IN1=IARIS
            IP1=IVECT(IN1)
            IF(IN1.LT.NARIS)THEN
              IN2=IN1+1
            ELSE
              IN2=1
            END IF
            IP2=IVECT(IN2)
C
            DO JARIS=1,NPOIN-NPOI0
              IF((IP1.EQ.LISTA_DE_ARISTAS(1,JARIS).AND.
     .            IP2.EQ.LISTA_DE_ARISTAS(2,JARIS)).OR.
     .           (IP1.EQ.LISTA_DE_ARISTAS(2,JARIS).AND.
     .            IP2.EQ.LISTA_DE_ARISTAS(1,JARIS)))THEN
                IVECT(NARIS+IARIS)=JARIS+NPOI0
                PRESS(NARIS+IARIS)=(PRESS(IN1)+PRESS(IN2))/2.
                GOTO 590
              END IF
            END DO
            WRITE(6,*)' ATENCION: ARISTA NO IDENTIFICADA',IN1
            WRITE(6,*)'           CARGAS NO INTERPOLADAS'
  590     CONTINUE
          WRITE(6,900)IEDGE,IELEM,IT,(IVECT(I),I=1,2*NARIS)
          WRITE(6,'(8F10.3)')(PRESS(I),I=1,2*NARIS)
        END DO
        END IF
C
  690 CONTINUE
C
      STOP
      END
