C  ************************************************************************
C
C  ESTE PROGRAMA ESCRIBE ARCHIVOS NECESARIOS PARA LA
C  REPRESENTACIO DE LAS TENSIONES EFECTIVAS DE 
C  VON MISES & DRUCKER PRAGER
C
C  ************************************************************************
C
C
C
C
      INTEGER nelem(80000),elemtype(80000)
      REAL pg(10),j2,aux,vm,t1,t2,t3,t4,t5,t6,alpha
	REAL fi,pi,i_uno,dp,r_j2
      character*80 datexp2,datexp3,datexp4,datexp5,ardrac1,titul

      data nw/2/
      data npg_prsm/6/
	data npg_tetr/1/
	data pi/3.14159/
C
C       INGRESOS DE LOS DATOS NECESARIOS
C
      
      write(6,*) 'Nombre del fichero de tensiones en puntos de gauss:'
      read(5,100) ardrac1
      write(6,*) 'Numero de elementos TOTAL:'
      read(5,99)  numec
	write(6,*) 'Nombre del fichero salida tensiones efectivas VM PRSM :'
      read(5,100) datexp2
	write(6,*) 'Nombre del fichero salida tensiones efectivas VM TETR :'
      read(5,100) datexp3
	write(6,*) 'Nombre del fichero salida tensiones efectivas DP PRSM :'
      read(5,100) datexp4
	write(6,*) 'Nombre del fichero salida tensiones efectivas DP TETR :'
      read(5,100) datexp5
c****  genera nombre archivos salidas basicos

      open(unit=15, file=ardrac1, status='old')
	open(unit=2, file=datexp2, carriagecontrol='list', status='new')
	open(unit=3, file=datexp3, carriagecontrol='list', status='new')
	open(unit=4, file=datexp4, carriagecontrol='list', status='new')
	open(unit=5, file=datexp5, carriagecontrol='list', status='new')

C 
C       LEE EN FICHERO DE ENTRADA : TENSIONES
C
      r3=SQRT(3.0)
	fi=40*pi/180
	sin_fi=SIN(fi)
	alpha=(2*sin_fi)/(r3*(3-sin_fi))


	read(15,100) titul
	
	nfiles=0
	do ielem=1,numec
	read (15,101) nelem(ielem),elemtype(ielem)

	   if (elemtype(ielem)==2) then
	       do jpg=1,npg_prsm
	          nfiles=nfiles+1
	          read(15,102) (pg(ind),ind=1,6)
                t1=(pg(1)-pg(2))*(pg(1)-pg(2))
	          t2=(pg(3)-pg(1))*(pg(3)-pg(1))
	          t3=(pg(2)-pg(3))*(pg(2)-pg(3))
	          t4=pg(4)*pg(4)
	          t5=pg(5)*pg(5)
	          t6=pg(6)*pg(6)
	          j2=(t1+t2+t3+t4+t5+t6)/6
	          aux=j2*3
	          vm=SQRT(aux)
	          i_uno=-(pg(1)+pg(2)+pg(3))
	          r_j2=SQRT(j2)
			  dp=r3*(alpha*i_uno+r_j2)
			  if (jpg==1)  then
			     write(2,103) nelem(ielem),vm
			     write(4,103) nelem(ielem),dp
			  else 
			  write(2,104) vm
			  write(4,104) dp
			  end if   			   
	       end do
	   end if

         if (elemtype(ielem)==4) then
	       do jpg=1,npg_tetr
	          nfiles=nfiles+1
	          read(15,102) (pg(ind),ind=1,6)
                t1=(pg(1)-pg(2))*(pg(1)-pg(2))
	          t2=(pg(3)-pg(1))*(pg(3)-pg(1))
	          t3=(pg(2)-pg(3))*(pg(2)-pg(3))
	          t4=pg(4)*pg(4)
	          t5=pg(5)*pg(5)
	          t6=pg(6)*pg(6)
	          j2=(t1+t2+t3+t4+t5+t6)/6
	          aux=j2*3
	          vm=SQRT(aux)
	          i_uno=-(pg(1)+pg(2)+pg(3))
	          r_j2=SQRT(j2)
			  dp=r3*(alpha*i_uno+r_j2)
			  if (jpg==1)  then
			     write(3,103) nelem(ielem),vm
			     write(5,103) nelem(ielem),dp
	          else 
			  write(3,104) vm
			  write(5,104) dp
			  end if   			   
	       end do
	   end if



	end do
	

      
C************** FORMATOS DE ESCRITURA  *******************
   99 format(i5)
  100 format(a80)
  101 format(1X,I5,1X,I5)
  102 format(6(1X,es12.5))
  103 format(I5,2(1X,F10.5))
  104 format(2(1X,F10.5))
CCCCCCCCCCCCCCCCCCCCCCCCC
C********************************************************
C
      close(unit=15)
      close(unit=2)
	close(unit=3)
C
      stop
      end