C  ************************************************************************
C
C  ESTE PROGRAMA ESCRIBE ARCHIVOS NECESARIOS PARA LA
C  REPRESENTACIO DE LAS TENSIONES EFECTIVAS DE 
C  VON MISES & DRUCKER PRAGER
C
C  ************************************************************************
C
C
C
C
      data elemppila/3/
      data npg_prsm/8/
	INTEGER nelem(80000),elemtype(80000),vm_elem(8)
	INTEGER dp_elem(8)
	INTEGER pila(3,50000),elem_pila,n_pila,numec,npg_prsm
      REAL*8 pg(10),j2,aux,vm,t1,t2,t3,t4,t5,t6,alpha
	REAL*8 fi,pi,i_uno,dp,r_j2,VM_max,DP_max
	REAL*8 teffVM(9,80000),teffDP(9,80000)
	REAL*8 VM_pila(3,8),DP_pila(3,8),VM_max_elem(3),DP_max_elem(3)
      character*80 datexp2,datexp3,datexp4,datexp5,ardrac1,ardrac2,titul

      data nw/2/
	data npg_tetr/1/
      data pi/3.14159/
C
C       INGRESOS DE LOS DATOS NECESARIOS
C
      
      write(6,*) 'Nombre del fichero de tensiones en puntos de gauss:'
      read(5,100) ardrac1
      write(6,*) 'Nombre del fichero de PILAS:'
      read(5,100) ardrac2
      write(6,*) 'Numero de elementos TOTAL:'
      read(5,99)  numec
      write(6,*) 'Numero de PILAS:'
      read(5,99)  n_pila
	write(6,*) 'Nombre del fichero salida tensiones efectivas VM PRSM :'
      read(5,100) datexp2
	write(6,*) 'Nombre del fichero salida tensiones efectivas DP PRSM :'
      read(5,100) datexp4

c****  genera nombre archivos salidas basicos

      open(unit=15, file=ardrac1, status='old')
      open(unit=16, file=ardrac2, status='old')
	open(unit=2, file=datexp2, carriagecontrol='list', status='new')
	open(unit=4, file=datexp4, carriagecontrol='list', status='new')

C 
C       LEE EN FICHERO DE ENTRADA : PILAS
C

      read(16,100) titul
	do ipila=1,n_pila
	   read(16,201) (pila(ind,ipila),ind=1,elemppila)
	end do

C 
C       LEE EN FICHERO DE ENTRADA : TENSIONES
C
      r3=SQRT(3.0)
	fi=70*pi/180
	sin_fi=SIN(fi)
	alpha=(2*sin_fi)/(r3*(3-sin_fi))


	read(15,100) titul
	
	nfiles=0
	do ielem=1,numec
	read (15,101) nelem(ielem),elemtype(ielem)

	   if (elemtype(ielem)==2) then
	          nfiles=nfiles+1
	      do jpg=1,npg_prsm
	          read(15,102) (pg(ind),ind=1,6)
                t1=(pg(1)-pg(2))*(pg(1)-pg(2))
	          t2=(pg(3)-pg(1))*(pg(3)-pg(1))
	          t3=(pg(2)-pg(3))*(pg(2)-pg(3))
	          t4=pg(4)*pg(4)
	          t5=pg(5)*pg(5)
	          t6=pg(6)*pg(6)
	          j2=(t1+t2+t3+t4+t5+t6)/6
	          aux=j2*3
	          vm=SQRT(aux)
	          i_uno=-(pg(1)+pg(2)+pg(3))
	          r_j2=SQRT(j2)
			  dp=r3*(alpha*i_uno+r_j2)
	          teffVM(jpg,nelem(ielem))= vm
	          teffDP(jpg,nelem (ielem))= dp
	       end do
      
	   end if

         if (elemtype(ielem)==4) then
	      do jpg=1,npg_tetr
	      read(15,102) (pg(ind),ind=1,6)
		  end do
	   end if    
	end do
	
      do ipila=1,n_pila
         do jepila=1,elemppila
            elem_pila=pila(jepila,ipila)
	      do jpg=1,npg_prsm
            VM_pila(jepila,jpg)=teffVM(jpg,elem_pila)
	      DP_pila(jepila,jpg)=teffDP(jpg,elem_pila)
	      
		  end do
      	end do

	do jepila=1,elemppila
         VM_max_elem(jepila)=DMAX1(VM_pila(jepila,1),VM_pila(jepila,2),
     + VM_pila(jepila,3),VM_pila(jepila,4),VM_pila(jepila,5),
     + VM_pila(jepila,6),VM_pila(jepila,7),VM_pila(jepila,8))
	   DP_max_elem(jepila)=DMAX1(DP_pila(jepila,1),DP_pila(jepila,2),
     + DP_pila(jepila,3),DP_pila(jepila,4),DP_pila(jepila,5),
     + DP_pila(jepila,6),DP_pila(jepila,7),DP_pila(jepila,8))
	end do
	VM_max=DMAX1(VM_max_elem(1),VM_max_elem(2),VM_max_elem(3))
	DP_max=DMAX1(DP_max_elem(1),DP_max_elem(2),DP_max_elem(3))
	write(2,103) ipila,VM_max
	write(4,103) ipila,DP_max   
	end do
C		      
C************** FORMATOS DE ESCRITURA  *******************
   99 format(i5)
  100 format(a80)
  101 format(1X,I5,1X,I5)
  102 format(6(1X,es12.5))
  103 format(I5,2(1X,F10.5))
  104 format(2(1X,F10.5))
  201 format(5I7)
CCCCCCCCCCCCCCCCCCCCCCCCC
C********************************************************
C
      close(unit=15)
	close(unit=16)
      close(unit=2)
	close(unit=4)
C
      stop
      end