%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Programa que genera els arxius per al cas que s'imposi una carrega  %%
%% de tipus sinusoidal. Incorpora tambe definicio de la lamina sup.    %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
ncarga=input('numero d_elements amb carrega: ');
nelem=input('num. d_elements: ');
%llegeix fitxer de CONECTIVITATS    
file2=fopen('drac.conec','r');
titol=fgetl(file2);
file4=fopen('drac2.conec','w');
fprintf(file4,'%s NEW!\r\n',titol);
for ielem=1:nelem
    aux=fgetl(file2);
    aux2=sscanf(aux,'%i',90);
    conec_elem(ielem,:)=aux2';
    fprintf(file4,'%5i%5i%5i%7i%7i%7i%7i%7i%7i\r\n',aux2');
end
fclose(file2);
fclose(file4);
%Es defineix la superficie superior on va la carrega distribuida
elemppila=input('quants elements hi ha a cada pila: ');
mprism='drac2.conec';
fnode='drac.coord';
[titol,A]=hdrload(mprism);
nelec=length(A(:,1));
lnodc=A(:,4:9);
lnodc=lnodc';
n_pila=1;
n_colum_pila=1;
for ielem=1:nelec;
    pila(n_colum_pila,n_pila)=ielem;
    k_pila(n_colum_pila,n_pila)=A(ielem,1);
    n_colum_pila=n_colum_pila+1;
    if n_colum_pila==(elemppila+1);
        n_pila=n_pila+1;
        n_colum_pila=1;
    end
end
n_pila=n_pila - 1;
for ipila=1:n_pila;
    for jelem_pila=1:elemppila;
        ielem_pila=pila(jelem_pila,ipila);
        aux=[];
        aux=lnodc(:,ielem_pila)';
        lnodc(1,ielem_pila)=aux(4);
        lnodc(2,ielem_pila)=aux(6);
        lnodc(3,ielem_pila)=aux(5);
        lnodc(4,ielem_pila)=aux(1);
        lnodc(5,ielem_pila)=aux(3);
        lnodc(6,ielem_pila)=aux(2);
      end
      if elemppila==2
        aux_2=pila(1,ipila);
        pila(1,ipila)=pila(2,ipila);
        pila(2,ipila)=aux_2;
      elseif elemppila==3; 
        aux_2=pila(1,ipila);
        pila(1,ipila)=pila(3,ipila);
        pila(3,ipila)=aux_2;
    elseif elemppila==4;
        aux_2=pila(1,ipila);
        aux_3=pila(2,ipila);
        pila(1,ipila)=pila(4,ipila);
        pila(2,ipila)=pila(3,ipila);
        pila(4,ipila)=aux_2;
        pila(3,ipila)=aux_3;
    end
    end

FID=fopen('drac_new.conec','w');
fprintf(FID,'noves conectivitats elements PRISM\r\n');
for ielem=1:nelec
    fprintf(FID,'%5i%5i%5i%5i%5i%5i%5i%5i%5i\r\n',A(ielem,1:3),lnodc(1:6,ielem)');
end
fclose(FID);

FID2=fopen('drac_piles.conec','w');
fprintf(FID2,'PRISM a cada pila\r\n');

if elemppila==2;
    for kpila=1:(n_pila/2)
    jpila=kpila+(n_pila/2);
    fprintf(FID2,'%7i%7i%7i%7i\r\n',pila(:,kpila)',pila(:,jpila)');
    end
end

    for ipila=1:n_pila
        if elemppila==3;
        fprintf(FID2,'%7i%7i%7i\r\n',pila(:,ipila)');
        elseif elemppila==4;
        fprintf(FID2,'%7i%7i%7i%7i\r\n',pila(:,ipila)');
        end
    end
fclose(FID2);

npilas=length(pila(1,:));
lnodc_TRI=[];
fid1=fopen('lamina.conec','w');
fprintf(fid1,'conectivitats elements lamina TRI\r\n');
for i=1:npilas
    elem_sup=pila(elemppila,i);
    lnodc_TRI(:,i)=lnodc(4:6,elem_sup);
    fprintf(fid1,'%7i%7i%7i%7i\r\n',i,lnodc_TRI(1:3,i)');
end
fclose(fid1);
%Selecciona els nodes de la lamina exterior;
[titol,A]=hdrload(fnode);
nnode=length(A(:,1));
nodes_lamina=zeros(1,nnode);
    for jpila=1:npilas
        for kelem=1:3
            node=lnodc_TRI(kelem,jpila);
            nodes_lamina(node)=1;
        end
    end
    coord=[];
    coord_ext=0;
fid2=fopen('lamina.coord','w');
fprintf(fid1,'cordenades elements lamina TRI\r\n');


for inode=1:nnode
    if nodes_lamina(inode)==1
        coord_ext=coord_ext+1;
        coord(coord_ext,:)=A(inode,:);
         fprintf(fid2,'%5i%15.5f%15.5f%15.5f\r\n',coord(coord_ext,:));
    end
end
fclose(fid2);   

file1=fopen('drac.carga','r');
titol=fgetl(file1);
for icarga=1:ncarga;
    line1=fgetl(file1);
    line_num=str2num(line1);
    fix_carga(icarga,:)=line_num(1:3);
    conec_carga(icarga,:)=line_num(4:6);
    line2=fgetl(file1);
    line_num=str2num(line2);
    prsn=line_num;
end
%es defineix la carrega sinusoidal pels nodes de la lamina ext.
q0=1000
a=4.2
b=4.2
for icarga=1:ncarga
    for jnode=1:3;
        node_carga=conec_carga(icarga,jnode);
        for i=1:coord_ext
           if node_carga==coord(i,1);
                x_node_carga=coord(i,2);
                y_node_carga=coord(i,3);
                prsn2(icarga,jnode)=q0*(sin(pi*x_node_carga/a))*(sin(pi*y_node_carga/b));
            end
        end
    end
end
             
file3=fopen('verdat1.carga','w');
fprintf(file3,'CC carrega \r\n');
for icarga=1:ncarga
   fprintf(file3,'%5i%5i%5i%5i%5i%5i\r\n',fix_carga(icarga,:),conec_carga(icarga,:));
   fprintf(file3,'%8.2f%8.2f%8.2f\r\n',prsn2(icarga,:));
end

fclose(file1);
fclose(file3);
